;;; "buildscm.scm" SLIB alist-table database	 -*-scheme-*-

(
 (30
  ("socket.c" c-source optional "BSD socket interface.")
  ("unix.c" c-source optional "non-posix system calls on unix systems.")
  ("posix.c" c-source optional "posix library interface.")
  ("ioext.c" c-source optional "system calls in common between PC compilers and unix.")
  ("gsubr.c" c-source optional "make_gsubr for arbitrary (< 11) arguments to C functions.")
  ("record.c" c-source optional "proposed `Record' user definable datatypes.")
  ("split.scm" scheme test "example use of crs.c.  Input, output, and diagnostic output directed to separate windows.")
  ("crs.c" c-source optional "interactive terminal control.")
  ("rgx.c" c-source optional "string regular expression match.")
  ("dynl.c" c-source optional "dynamically load object files.")
  ("sc2.c" c-source optional "procedures from R2RS and R3RS not in R4RS.")
  ("ramap.c" c-source optional "array mapping")
  ("unif.c" c-source required "uniform vectors.")
  ("subr.c" c-source required "the rest of IEEE functions.")
  ("sys.c" c-source required "call-with-current-continuation, opening and closing files, storage allocation and garbage collection.")
  ("eval.c" c-source required "evaluator, apply, map, and foreach.")
  ("scl.c" c-source required "non-integer arithmetic and non-IEEE utility functions.")
  ("repl.c" c-source required "error, read-eval-print loop, read, write and load.")
  ("time.c" c-source required "functions dealing with time.")
  ("scm.c" c-source required "top level and interrupts.")
  ("scm.h" c-header required "data type and external definitions of SCM.")
  ("setjump.h" c-header required "continuations, stacks, and memory allocation.")
  ("patchlvl.h" c-header required "patchlevel of this release.")
  ("scmfig.h" c-header required "contains system dependent definitions.")
  ("Link.scm" scheme required "compiles and dynamically links.")
  ("Transcen.scm" scheme required "inexact builtin procedures.")
  ("Init.scm" scheme required "Scheme initialization.")
  ("setjump.s" cray-asm required "provides setjmp and longjmp for the Cray YMP.")
  ("setjump.mar" vax-asm required "provides setjmp and longjmp which do not use $unwind utility on VMS.")
  ("buildscm.scm" scheme required "database for compiling and linking new SCM programs.")
  ("Makefile" makefile required "builds SCMLIT using the `make' program.")
  ("pi.c" c-source test "computes digits of pi [cc -o pi pi.c;time pi 100 5].")
  ("pi.scm" scheme test "computes digits of pi [type (pi 100 5)].  Test performance against pi.c.")
  ("example.scm" scheme test "example from R4RS which uses inexact numbers.")
  ("test.scm" scheme test "tests conformance with Scheme specifications.")
  ("ChangeLog" plaintext documentation "changes to SCM.")
  ("scm.texi" texinfo documentation "SCM installation and use.")
  ("QUICKREF" plaintext documentation "Quick Reference card for R4RS and IEEE Scheme.")
  ("scm.doc" plaintext documentation "man page generated from scm.1.")
  ("scm.1" nroff documentation "unix style man page.")
  ("COPYING" plaintext documentation "details the LACK OF WARRANTY for SCM and the conditions for distributing SCM.")
  ("README" plaintext documentation "contains a MANIFEST, INSTALLATION INSTRUCTIONS, hints for EDITING SCHEME CODE, and a TROUBLE SHOOTING GUIDE.")
 )
 (29
  (4 #f what #f string)
  (3 #f category #f file-categories)
  (2 #f format #f file-formats)
  (1 #t file #f string)
 )
 (28
  (test)
  (optional)
  (required)
  (documentation)
 )
 (27
  (1 #t category #f symbol)
 )
 (26
  (texinfo)
  (nroff)
  (makefile)
  (cray-asm)
  (vax-asm)
  (scheme)
  (c-header)
  (c-source)
  (plaintext)
 )
 (25
  (1 #t format #f symbol)
 )
 (24
  (#(object *unknown*) (lambda (item) (list (list (quote c-file) item))))
  (#(feature generalized-c-arguments) (quote ((c-file "gsubr.c") (init "init_gsubr"))))
  (#(feature unix) (quote ((c-file "unix.c") (init "init_unix"))))
  (#(feature turtlegr) (quote ((c-file "turtlegr.c") (c-lib graphics) (init "init_turtlegr"))))
  (#(feature socket) (quote ((c-file "socket.c") (init "init_socket"))))
  (#(feature rev2-procedures) (quote ((c-file "sc2.c") (init "init_sc2"))))
  (#(feature regex) (quote ((c-file "rgx.c") (c-lib regex) (init "init_rgx"))))
  (#(feature record) (quote ((c-file "record.c") (init "init_record"))))
  (#(feature posix) (quote ((c-file "posix.c") (init "init_posix"))))
  (#(feature i/o-extensions) (quote ((c-file "ioext.c") (init "init_ioext"))))
  (#(feature curses) (quote ((c-file "crs.c") (c-lib curses) (init "init_crs"))))
  (#(feature dynamic-linking) (quote ((c-file "dynl.c") (c-lib dlll))))
  (#(feature windows) (quote ((c-lib windows))))
  (#(feature poll) (quote ((define "NON_PREEMPTIVE"))))
  (#(feature tick-interrupts) (quote ((define "TICKS"))))
  (#(feature memoize-local-bindings) (quote ((define "MEMOIZE_LOCALS"))))
  (#(feature cheap_continuations) (quote ((define "CHEAP_CONTINUATIONS"))))
  (#(feature heap-can-shrink) (quote ((define "GC_FREE_SEGMENTS"))))
  (#(feature stack-limit) (quote ((define "STACK_LIMIT" "(HEAP_SEG_SIZE/2)"))))
  (#(feature sicp) (quote ((define "SICP"))))
  (#(feature compiled-closure) (quote ((define "CCLO"))))
  (#(feature single-precision-only) (quote ((define "SINGLESONLY"))))
  (#(feature engineering-notation) (quote ((define "ENGNOT"))))
  (#(feature inexact) (quote ((define "FLOATS") (c-lib m))))
  (#(feature arrays) (quote ((define "ARRAYS") (c-file "ramap.c") (init "init_ramap"))))
  (#(feature bignums) (quote ((define "BIGNUMS"))))
  (#(feature careful-interrupt-masking) (quote ((define "CAREFUL_INTS"))))
  (#(feature cautious) (quote ((define "CAUTIOUS"))))
  (#(feature reckless) (quote ((define "RECKLESS"))))
  (#(dlll generalized-c-arguments) (quote ((target dlll "gsubr") (dll-c-file "gsubr.c") (dll-init "init_gsubr"))))
  (#(dlll unix) (quote ((target dlll "unix") (dll-c-file "unix.c") (dll-init "init_unix"))))
  (#(dlll turtlegr) (quote ((target dlll "turtlegr") (dll-c-file "turtlegr.c") (dll-init "init_turtlegr") (c-lib x11))))
  (#(dlll socket) (quote ((target dlll "socket") (dll-c-file "socket.c") (dll-init "init_socket"))))
  (#(dlll rev2-procedures) (quote ((target dlll "sc2") (dll-c-file "sc2.c") (dll-init "init_sc2"))))
  (#(dlll regex) (quote ((target dlll "rgx") (dll-c-file "rgx.c") (dll-init "init_rgx"))))
  (#(dlll record) (quote ((target dlll "record") (dll-c-file "record.c") (dll-init "init_record"))))
  (#(dlll posix) (quote ((target dlll "posix") (dll-c-file "posix.c") (dll-init "init_posix"))))
  (#(dlll i/o-extensions) (quote ((target dlll "ioext") (dll-c-file "ioext.c") (dll-init "init_ioext"))))
  (#(dlll curses) (quote ((target dlll "crs") (dll-c-file "crs.c") (dll-init "init_crs") (c-lib curses))))
  (#(library scm) (quote ((target library "scm") (define "RTL"))))
  (#(executable scm) (begin (require (quote object->string)) (cons (quote (target executable "scm")) (cons (list (quote define) "IMPLINIT" (object->string (in-vicinity (implementation-vicinity) "Init.scm"))) (map (lambda (f) (list (quote c-file) (string-append f ".c"))) (quote ("eval" "repl" "scl" "scm" "subr" "sys" "time" "unif")))))))
 )
 (23
  (3 #f spec #f expression)
  (2 #t target #f symbol)
  (1 #t kind #f symbol)
 )
 (22
  (#(make-dll-archive *unknown*) (lambda (oname objects) (plan-to "ar rc" (string-append oname ".a") objects) (plan-to "ranlib" (string-append oname ".a"))) (lambda (oname objects) (string-append oname ".a")))
  (#(compile-dll-c-file *unknown*) (lambda (file includes defines) (plan-to "cc" "-O" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(make-archive *unknown*) (lambda (oname objects) (plan-to "ar rc" (string-append oname ".a") objects) (plan-to "ranlib" (string-append oname ".a"))) (lambda (oname objects) (string-append oname ".a")))
  (#(link-c-program *unknown*) (lambda (oname objects libs) (if (file-exists? oname) (plan-to "mv" "-f" oname (string-append oname "~"))) (plan-to "cc" "-o" oname objects libs)) (lambda (oname objects libs) oname))
  (#(compile-c-file *unknown*) (lambda (file includes defines) (plan-to "cc" "-O" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program vms-gcc) (lambda (oname objects libs) (let ((exe (change-suffix (car objects) ".obj" ".exe")) (oexe (string-append oname ".exe"))) (plan-to "$" "macro" "setjump") (plan-to "$" "link" (apply string-join "," (append objects (quote ("setjump.obj" "sys$input/opt"))))) (plan-to " " (apply string-join "," (append (remove "" libs) (quote ("gnu_cc:[000000]gcclib/lib" "sys$share:vaxcrtl/share"))))) (if (not (string-ci=? exe oexe)) (plan-to "$" "rename" exe oexe)))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file vms-gcc) (lambda (file includes defines) (plan-to "$" "gcc" includes (command-line-defines defines) (change-suffix file ".c" ""))) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program vms) (lambda (oname objects libs) (let ((exe (change-suffix (car objects) ".obj" ".exe")) (oexe (string-append oname ".exe"))) (plan-to "$" "macro" "setjump") (plan-to "$" "link" (apply string-join "," (append (map (lambda (f) (change-suffix f ".obj" "")) objects) (quote ("setjump" "sys$input/opt"))))) (plan-to " " (apply string-join "," (append (remove "" libs) (quote ("sys$share:vaxcrtl/share"))))) (if (not (string-ci=? exe oexe)) (plan-to "$" "rename" exe oexe)))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file vms) (lambda (file includes defines) (plan-to "$" "cc" includes (command-line-defines defines) (change-suffix file ".c" ""))) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program acorn-unixlib) (lambda (oname objects libs) (plan-to "link" "-o" oname objects libs ":5.$.dev.gcc.unixlib36d.clib.o.unixlib") (plan-to "squeeze" oname)) (lambda (oname objects libs) oname))
  (#(compile-c-file acorn-unixlib) (lambda (file includes defines) (plan-to "cc" "-c" "-depend" "!Depend" "-IUnixLib:" "-pcc" "-Dunix" "-DSVR3" "-DARM_ULIB" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program atari-st-turbo-c) (lambda (oname objects libs) (plan-to "tlink" "-o" (string-append oname ".ttp") objects libs "mintlib.lib" "osbind.lib" "pcstdlib.lib" "pcfltlib.lib")) (lambda (oname objects libs) (string-append oname ".ttp")))
  (#(compile-c-file atari-st-turbo-c) (lambda (file includes defines) (plan-to "tcc" "-P" "-W-" "-Datarist" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program atari-st-gcc) (lambda (oname objects libs) (plan-to "gcc" "-v" "-o" (string-append oname ".ttp") objects libs)) (lambda (oname objects libs) (string-append oname ".ttp")))
  (#(compile-c-file atari-st-gcc) (lambda (file includes defines) (plan-to "gcc" "-v" "-O" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program amiga-dice-c) (lambda (oname objects libs) (plan-to "dcc" "-o" oname objects libs)) (lambda (oname objects libs) oname))
  (#(compile-c-file amiga-dice-c) (lambda (file includes defines) (plan-to "dcc" "-D" "AMIGA" "-mC" "-v" "-new" "-f" "-2.0" includes (command-line-defines defines) file "-o" (change-suffix file ".c" ".o") "-c")) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program amiga-sas/c-5.10) (lambda (oname objects libs) (plan-to "blink" oname (apply string-join "+" (append (quote ("LIB:lcmieee.lib")) libs objects)))) (lambda (oname objects libs) oname))
  (#(compile-c-file amiga-sas/c-5.10) (lambda (file includes defines) (plan-to "lc" "-d3" "-M" "-fi" "-O" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program amiga-aztec) (lambda (oname objects libs) (plan-to "cc" "-o" oname objects libs "-lma")) (lambda (oname objects libs) oname))
  (#(compile-c-file amiga-aztec) (lambda (file includes defines) (plan-to "cc" "-dAMIGA" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program aix) (lambda (oname objects libs) (plan-to "cc" "-lansi" "-o" oname objects libs)) (lambda (oname objects libs) oname))
  (#(compile-c-file aix) (lambda (file includes defines) (plan-to "cc" "-O" "-Dunix" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(compile-c-file svr4) (lambda (file includes defines) (plan-to "cc" "-O" "-DSVR4" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(compile-c-file gcc) (lambda (file includes defines) (plan-to "gcc" "-Wall" "-O2" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program unicos) (lambda (oname objects libs) (plan-to "cc" "setjump.o" "-o" oname objects libs)) (lambda (oname objects libs) oname))
  (#(compile-c-file unicos) (lambda (file includes defines) (plan-to "cc" "-hvector2" "-hscalar2" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program linux-elf) (lambda (oname objects libs) (plan-to "gcc-elf" "-rdynamic" "-o" oname objects libs)) (lambda (oname objects libs) oname))
  (#(make-dll-archive linux-elf) (lambda (oname objects) (plan-to "gcc-elf" "--shared" "-o" (string-append oname ".so") objects)) (lambda (oname objects) (string-append oname ".so")))
  (#(compile-dll-c-file linux-elf) (lambda (file includes defines) (plan-to "gcc-elf" "-O2" "-fpic" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(compile-c-file linux-elf) (lambda (file includes defines) (plan-to "gcc-elf" "-O2" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(make-dll-archive linux) (lambda (oname objects) #t) (lambda (oname objects) oname))
  (#(compile-dll-c-file linux) (lambda (file includes defines) (plan-to "gcc" "-Wall" "-O2" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(compile-c-file linux) (lambda (file includes defines) (plan-to "gcc" "-Wall" "-O2" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(make-dll-archive sun) (lambda (oname objects) (plan-to "ld" "-assert" "pure-text" "-o" (string-append oname ".so.1.0") objects)) (lambda (oname objects) (string-append oname ".so.1.0")))
  (#(make-dll-archive hp-ux) (lambda (oname objects) (plan-to "ld" "-b" "-o" (string-append oname ".sl") objects)) (lambda (oname objects) (string-append oname ".sl")))
  (#(compile-dll-c-file hp-ux) (lambda (file includes defines) (plan-to "cc" "+O1" "-Wl,-E" "+z" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(compile-c-file hp-ux) (lambda (file includes defines) (plan-to "cc" "+O1" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program os/2-cset) (lambda (oname objects libs) (plan-to "link386.exe" objects libs (string-append "," oname ".exe,,,;"))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file os/2-cset) (lambda (file includes defines) (plan-to "icc.exe" "/Gd-" "/Ge+" "/Gm+" "/Q" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program os/2-emx) (lambda (oname objects libs) (plan-to "gcc" "-o" (string-append oname ".exe") objects libs)) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file os/2-emx) (lambda (file includes defines) (plan-to "gcc" "-O" "-m386" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program djgpp) (lambda (oname objects libs) (let ((exe (string-append oname ".exe"))) (plan-to "gcc" "-o" oname objects libs "-lc") (plan-to "strip" oname) (plan-to "del" exe) (plan-to "coff2exe" "-s" "c:\\djgpp\\bin\\go32.exe" oname))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file djgpp) (lambda (file includes defines) (plan-to "gcc" "-Wall" "-O2" "-c" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".o")))
  (#(link-c-program watcom-9.0) (lambda (oname objects libs) (let ((exe (change-suffix (car objects) ".obj" ".exe")) (oexe (string-append oname ".exe"))) (if (not (string-ci=? exe oexe)) (plan-to "del" oexe)) (plan-to "wlinkp" "option" "quiet" "option" "stack=40000" "FILE" (apply string-join "," (map (lambda (o) (change-suffix o ".obj" "")) objects)) libs) (if (not (string-ci=? exe oexe)) (plan-to "rename" exe oexe)))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file watcom-9.0) (lambda (file includes defines) (plan-to "wcc386p" "/mf" "/d2" "/ze" "/oxt" "/3s" "/zq" "/w3" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program microsoft-quick-c) (lambda (oname objects libs) (define crf-name (string-append oname ".crf")) (call-with-output-file crf-name (lambda (p) (for-each (lambda (f) (display f p) (display " +" p) (newline p)) objects) (newline p) (display (string-append oname ".exe") p) (newline p) (display (apply string-join " " libs) p) (display ";" p) (newline p))) (plan-to "qlink" "/CP:0xffff" "/NOI" "/SE:0x80" "/ST:0x9c40" crf-name)) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file microsoft-quick-c) (lambda (file includes defines) (plan-to "qcl" "/AH" "/W1" "/Ze" "/O" "/Ot" "/DNDEBUG" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program microsoft-c) (lambda (oname objects libs) (let ((exe (change-suffix (car objects) ".obj" ".exe")) (oexe (string-append oname ".exe"))) (if (not (string-ci=? exe oexe)) (plan-to "del" oexe)) (plan-to "link" "/noe" "/ST:40000" (apply string-join "+" (map (lambda (o) (change-suffix o ".obj" "")) objects)) libs) (if (not (string-ci=? exe oexe)) (plan-to "rename" exe oexe)))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file microsoft-c) (lambda (file includes defines) (plan-to "cl" "-c" "Oxp" "-AH" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program turbo-c-2) (lambda (oname objects libs) (let ((exe (change-suffix (car objects) ".obj" ".exe")) (oexe (string-append oname ".exe"))) (if (not (string-ci=? exe oexe)) (plan-to "del" oexe)) (plan-to "tcc" "-Lc:\\turboc\\lib" libs objects) (if (not (string-ci=? exe oexe)) (plan-to "rename" exe oexe)))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file turbo-c-2) (lambda (file includes defines) (plan-to "tcc" "-c" "-d" "-O" "-Z" "-G" "-ml" "-c" "-Ic:\\turboc\\include" includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
  (#(link-c-program borland-c-3.1) (lambda (oname objects libs) (let ((exe (change-suffix (car objects) ".obj" ".exe"))) (plan-to "bcc" (string-append "-e" oname) "-ml" libs objects))) (lambda (oname objects libs) (string-append oname ".exe")))
  (#(compile-c-file borland-c-3.1) (lambda (file includes defines) (plan-to "bcc" "-d" "-O" "-Z" "-G" "-w-pro" "-ml" "-c" (if (member (quote ("FLOATS")) defines) "" "-f-") includes (command-line-defines defines) file)) (lambda (file includes defines) (change-suffix file ".c" ".obj")))
 )
 (21
  (4 #f result-name #f expression)
  (3 #f procedure #f expression)
  (2 #t platform #f platform)
  (1 #t name #f symbol)
 )
 (20
  (#(windows borland-c-3.1) "-N -W" "-W" #f)
  (#(graphics borland-c-3.1) "" "graphics.lib" #f)
  (#(m borland-c-3.1) "" "" #f)
  (#(graphics turbo-c-2) "" "graphics.lib" #f)
  (#(m turbo-c-2) "" "" #f)
  (#(m microsoft-quick-c) "" "" #f)
  (#(m microsoft-c) "" "" #f)
  (#(x11 hp-ux) "-DX11" "-lX" "/usr/lib/X11R5/libX11.sl")
  (#(dlll hp-ux) "-DHAVE_DYNL" "-Wl,-E -ldld" #f)
  (#(m hp-ux) "" "-lm" #f)
  (#(dlll sun) "-DSUN_DL" "-ldl" #f)
  (#(m sun) "" "-lm" #f)
  (#(m atari-st-turbo-c) "" "" #f)
  (#(m atari-st-gcc) "" "-lpml" #f)
  (#(m vms) "" "" #f)
  (#(m vms-gcc) "" "" #f)
  (#(m amiga-sas/c-5.10) "" "LIB:lc.lib" #f)
  (#(m amiga-dice-c) "" "-lml" #f)
  (#(m acorn-unixlib) "" "" #f)
  (#(curses linux-elf) "" "-lcurses" "/lib/elf/libncurses.so")
  (#(dlll linux-elf) "-DSUN_DL" "-ldl" #f)
  (#(c linux-elf) "" "-lc" "/lib/elf/libc.so")
  (#(m linux-elf) "" "-lm" "/lib/elf/libm.so")
  (#(curses linux) "-I/usr/include/ncurses" "-lncurses" "/usr/lib/libncurses.a")
  (#(dlll linux) "-DDLD -DDLD_DYNCM" "-ldld" #f)
  (#(c linux) "" "-lc" "/usr/lib/libc.sa")
  (#(m linux) "" "-lm" "/usr/lib/libm.sa")
  (#(x11 *unknown*) "-I/usr/local/X11R5/include -DX11" "-lX11" "/usr/X11/lib/libX11.a")
  (#(curses *unknown*) "" "-lcurses" "/usr/lib/libcurses.a")
  (#(regex *unknown*) "" "-lrgx" "/usr/lib/librgx.a")
  (#(c *unknown*) "" "-lc" "/usr/lib/libc.a")
  (#(m *unknown*) "" "-lm" "/usr/lib/libm.a")
 )
 (19
  (5 #f lib-path #f optstring)
  (4 #f link-lib-flag #f string)
  (3 #f compiler-flags #f string)
  (2 #t platform #f platform)
  (1 #t library #f symbol)
 )
 (18
  (*unknown* *unknown* unix *unknown*)
  (watcom-9.0 i386 ms-dos watcom)
  (vms-gcc vax vms gcc)
  (vms vax vms *unknown*)
  (unicos cray unicos *unknown*)
  (turbo-c-2 8086 ms-dos turbo-c)
  (svr4 *unknown* unix *unknown*)
  (sun sparc sun-os *unknown*)
  (os/2-cset i386 os/2 c-set++)
  (os/2-emx i386 os/2 gcc)
  (microsoft-quick-c 8086 ms-dos microsoft-quick-c)
  (microsoft-c 8086 ms-dos microsoft-c)
  (linux-elf i386 linux gcc)
  (linux i386 linux gcc)
  (hp-ux hp-risc hp-ux *unknown*)
  (gcc *unknown* unix gcc)
  (djgpp i386 ms-dos gcc)
  (borland-c-3.1 8086 ms-dos borland-c)
  (atari-st-turbo-c m68000 atari.st turbo-c)
  (atari-st-gcc m68000 atari.st gcc)
  (amiga-sas/c-5.10 m68000 amiga sas/c)
  (amiga-aztec m68000 amiga aztec)
  (amiga-dice-c m68000 amiga dice-c)
  (aix powerpc aix *unknown*)
  (acorn-unixlib acorn *unknown* *unknown*)
 )
 (17
  (4 #f compiler #f symbol)
  (3 #f operating-system #f operating-system)
  (2 #f processor #f processor-family)
  (1 #t name #f symbol)
 )
 (16
  (*unknown*)
  (vms)
  (unix)
  (unicos)
  (transputer)
  (sun-os)
  (stratus)
  (sgi)
  (sequent)
  (pyramid)
  (psion)
  (prime)
  (os/2)
  (novell)
  (next)
  (newton)
  (ncr)
  (mips)
  (ms-dos)
  (masscomp)
  (mac)
  (linux)
  (isis)
  (hp48)
  (hp-ux)
  (harris)
  (encore)
  (convex)
  (concurrent)
  (celerity)
  (cdc)
  (atari.st)
  (arm)
  (apple2)
  (apollo)
  (amiga)
  (alliant)
  (aix)
  (acorn)
  (3b1)
 )
 (15
  (1 #t name #f symbol)
 )
 (14
  (*unknown* #f)
  (vax pdp-11)
  (tahoe #f)
  (sparc #f)
  (sequent #f)
  (pyramid #f)
  (powerpc #f)
  (pdp-8 #f)
  (pdp-11 #f)
  (pdp-10 #f)
  (nos/ve #f)
  (mips #f)
  (hp-risc #f)
  (cray #f)
  (acorn #f)
  (8086 #f)
  (i386 8086)
  (m68030 m68000)
  (m68000 #f)
 )
 (13
  (2 #f also-runs #f processor-family)
  (1 #t family #f atom)
 )
 (12
  (*initialize* no-parameters no-parameters (begin (define build:error slib:error) (define build:c-libraries #f) (define build:syscom #f) (define build:scm #f) (define build:lib-cc-flag #f) (define build:lib-ld-flag #f) (define build:dry-run #f) (define build:using-command-line-defines #f) (define (make-defaulting-platform-lookup getter) (lambda (thing) (define (look platform) (let ((ans (getter thing platform))) (cond (ans ans) ((eq? (quote *unknown*) platform) (build:error "Couldn't find: " thing)) (else (look (quote *unknown*)))))) (look build:platform))) (define (plan-command command) (define (plan platform) (let ((proc (slib:eval ((build:syscom (quote get) (quote procedure)) command platform))) (name (slib:eval ((build:syscom (quote get) (quote result-name)) command platform)))) (cond (proc (lambda args (apply proc args) (apply name args))) ((eq? (quote *unknown*) platform) (build:error (quote plan-command) "unsupported command: " command)) (else (plan (quote *unknown*)))))) (plan build:platform)) (define (plan:flatten strings) (apply append (map (lambda (obj) (cond ((eq? "" obj) (quote ())) ((string? obj) (list obj)) ((eq? #f obj) (quote ())) ((null? obj) (quote ())) ((list? obj) (plan:flatten obj)) (else (build:error (quote plan:flatten) "unexpected type" obj "in" strings)))) strings))) (define system:success? zero?) (define (plan-to . args) (let ((comstr (apply string-join " " (plan:flatten args)))) (display comstr) (newline) (cond ((not build:dry-run) (let ((sts (system comstr))) (cond ((system:success? sts)) (else (build:error (quote failed:) sts comstr)))))))) (define (string-join joiner . args) (if (null? args) "" (apply string-append (car args) (map (lambda (s) (string-append joiner s)) (cdr args))))) (define (scm:c-libs options) (let ((c-libs (assq (quote c-lib) options))) (if c-libs (map build:lib-ld-flag (map car (cdr c-libs))) (quote ())))) (define (scm:includes options) (let ((c-libs (assq (quote c-lib) options))) (if c-libs (map build:lib-cc-flag (map car (cdr c-libs))) (quote ())))) (define (scm:c-files options) (let ((c-files (assq (quote c-file) options))) (if c-files (map car (cdr c-files)) (quote ())))) (define (scm:dll-c-files options) (let ((dll-c-files (assq (quote dll-c-file) options))) (if dll-c-files (map car (cdr dll-c-files)) (quote ())))) (define (scm:targets options) (let ((targets (assq (quote target) options))) (if targets (cdr targets) (quote ())))) (define (scm:defines options) (let ((defines (assq (quote define) options))) (if defines (cdr defines) (quote ())))) (define (scm:inits options) (let ((init-procs (assq (quote init) options))) (if init-procs (list (list "INITS" (apply string-append (map (lambda (c) (string-append (car c) "();")) (cdr init-procs))))) (quote ())))) (define (command-line-defines defines) (cond (build:using-command-line-defines (require (quote object->string)) (map (lambda (def) (cond ((null? (cdr def)) (string-append "-D" (car def))) (else (string-append "-D" (car def) "=" (object->string (cadr def)))))) defines)) (else ""))) (define (change-suffix str old new) (let* ((len (string-length str)) (re (- len (string-length old)))) (cond ((string-ci=? old (substring str re len)) (string-append (substring str 0 re) new)) (else (build:error (quote change-suffix) "suffix doens't match:" old str))))) (define (write-c-defines-to-file defines file) (cond ((not build:using-command-line-defines) (display file) (display ":") (newline) ((lambda (f) (if build:dry-run (f #f) (call-with-output-file file f))) (lambda (p) (cond (p (newline p))) (for-each (lambda (d) (let ((line (apply string-join " " "#define" d))) (display line) (newline) (cond (p (display line p) (newline p))))) defines))) (newline)))) (define (scm:build specs) (define options (scm:specs->options specs)) (let ((targets (scm:targets options)) (includes (scm:includes options)) (defines (append (scm:inits options) (scm:defines options))) (huhs (remove-if (lambda (p) (memq (car p) (quote (define target c-file dll-c-file c-lib init dll-init)))) options))) (if (not (null? huhs)) (build:error (quote scm:build) "unknown attributes: " huhs)) (write-c-defines-to-file defines "scmflags.h") (let* ((compile-c-file (plan-command (quote compile-c-file))) (compile-dll-c-file (plan-command (quote compile-dll-c-file))) (o-files (map (lambda (f) (compile-c-file f includes defines)) (scm:c-files options))) (dll-o-files (map (lambda (f) (compile-dll-c-file f includes defines)) (scm:dll-c-files options)))) (map (lambda (target) (case (car target) ((executable) ((plan-command (quote link-c-program)) (cadr target) o-files (scm:c-libs options))) ((library) ((plan-command (quote make-archive)) (cadr target) o-files)) ((dlll) ((plan-command (quote make-dll-archive)) (cadr target) dll-o-files)))) targets)))) (define (build:group-by-attribute specs) (define al (quote ())) (define add-it (let ((getter (alist-inquirer eq?)) (putter (alist-associator eq?))) (lambda (key val) (set! al (putter al key (adjoin val (or (getter al key) (quote ())))))))) (for-each (lambda (spec) (add-it (car spec) (cdr spec))) specs) al) (define (scm:specs->options specs) (build:group-by-attribute (apply append (map scm:expand-spec specs)))) (define (scm:expand-spec spec) (let ((type (car spec)) (item (cadr spec)) (scm:lookup (build:scm (quote get) (quote spec))) (ans #f)) (set! ans (slib:eval (scm:lookup type item))) (cond (ans ans) (else (set! ans (slib:eval (scm:lookup type (quote *unknown*)))) (cond (ans (apply ans item (quote ()))) (else (build:error (quote scm:expand-spec) "don't understand: " type item))))))) (define build:platform (software-type)) (cond ((eq? (quote unix) build:platform) (let ((file-name (tmpnam))) (system (string-append "uname > " file-name)) (set! build:platform (call-with-input-file file-name read)) (delete-file file-name)))) (require (quote alist)) (require (quote common-list-functions)) (display "SCM Build Database - ready to build") (newline) (display "Type: (scm:build '((executable scm)))") (newline) (lambda (build:db) (define build:open-table (build:db (quote open-table))) (set! build:c-libraries (build:open-table (quote c-libraries) #f)) (set! build:syscom (build:open-table (quote system-commands) #f)) (set! build:scm (build:open-table (quote scm-build) #f)) (set! build:lib-cc-flag (make-defaulting-platform-lookup (build:c-libraries (quote get) (quote compiler-flags)))) (set! build:lib-ld-flag (make-defaulting-platform-lookup (build:c-libraries (quote get) (quote link-lib-flag)))))) "SCM Build Database")
  (delete-domain no-parameters no-parameter-names (lambda (rdb) (((rdb (quote open-table)) (quote *domains-data*) #t) (quote row:remove))) "given its name, delete a domain")
  (add-domain no-parameters no-parameter-names (lambda (rdb) (((rdb (quote open-table)) (quote *domains-data*) #t) (quote row:insert))) "given the row describing it, add a domain")
  (domain-checker no-parameters no-parameter-names (lambda (rdb) (let* ((ro:domains ((rdb (quote open-table)) (quote *domains-data*) #f)) (ro:get-dir (ro:domains (quote get) (quote domain-integrity-rule))) (ro:for-tab (ro:domains (quote get) (quote foreign-table)))) (lambda (domain) (let ((fkname (ro:for-tab domain)) (dir (slib:eval (ro:get-dir domain)))) (cond (fkname (let* ((fktab ((rdb (quote open-table)) fkname #f)) (p? (fktab (quote get) 1))) (cond (dir (lambda (e) (and (dir e) (p? e)))) (else p?)))) (else dir)))))) "return procedure to check given domain name")
 )
 (11
  (5 #f documentation #f string)
  (4 #f procedure #f expression)
  (3 #f parameter-names #f parameter-name-translation)
  (2 #f parameters #f parameter-list)
  (1 #t name #f symbol)
 )
 (10
 )
 (9
  (2 #f parameter-index #f uint)
  (1 #t name #f string)
 )
 (8
 )
 (7
  (6 #f documentation #f string)
  (5 #f default #f expression)
  (4 #f domain #f domain)
  (3 #f arity #f parameter-arity)
  (2 #f name #f symbol)
  (1 #t index #f uint)
 )
 (6
  (nary1 (lambda (a) (not (null? a))) identity)
  (nary (lambda (a) #t) identity)
  (boolean (lambda (a) (or (null? a) (and (pair? a) (null? (cdr a)) (boolean? (car a))))) (lambda (a) (if (null? a) #f (car a))))
  (optional (lambda (lambda (a) (or (null? a) (and (pair? a) (null? (cdr a)))))) identity)
  (single (lambda (a) (and (pair? a) (null? (cdr a)))) car)
 )
 (5
  (3 #f procedure #f expression)
  (2 #f predicate? #f expression)
  (1 #t name #f symbol)
 )
 (4
  (file-categories file-categories #f symbol #f)
  (file-formats file-formats #f symbol #f)
  (platform platform #f symbol #f)
  (operating-system operating-system #f symbol #f)
  (processor-family processor-family #f atom #f)
  (optstring #f (lambda (x) (or (not x) (string? x))) string #f)
  (parameter-arity parameter-arity #f symbol #f)
  (parameter-name-translation *catalog-data* #f symbol #f)
  (parameter-list *catalog-data* #f symbol #f)
  (domain *domains-data* #f atom #f)
  (string #f string? string #f)
  (symbol #f symbol? symbol #f)
  (boolean #f boolean? boolean #f)
  (expression #f #f expression #f)
  (uint #f (lambda (x) (and (number? x) (integer? x) (not (negative? x)))) integer #f)
  (base-id #f (lambda (x) (or (symbol? x) (number? x))) base-id #f)
  (type #f #f symbol #f)
  (atom #f (lambda (x) (or (not x) (symbol? x) (number? x))) atom #f)
 )
 (3
  (6 #f view-procedure #f expression)
  (5 #f user-integrity-rule #f expression)
  (4 #f bastab-id #f base-id)
  (3 #f coltab-name #f atom)
  (2 #f column-limit #f uint)
  (1 #t table-name #f atom)
 )
 (2
  (5 #f type-param #f expression)
  (4 #f type-id #f type)
  (3 #f domain-integrity-rule #f expression)
  (2 #f foreign-table #f atom)
  (1 #t domain-name #f atom)
 )
 (1
  (5 #f domain-name #f domain)
  (4 #f column-integrity-rule #f expression)
  (3 #f column-name #f symbol)
  (2 #f primary-key? #f boolean)
  (1 #t column-number #f uint)
 )
 (0
  (manifest 4 desc:manifest 30 #f #f)
  (desc:manifest 5 *columns* 29 #f #f)
  (file-categories 1 desc:file-categories 28 #f #f)
  (desc:file-categories 5 *columns* 27 #f #f)
  (file-formats 1 desc:file-formats 26 #f #f)
  (desc:file-formats 5 *columns* 25 #f #f)
  (scm-build 3 desc:scm-build 24 #f #f)
  (desc:scm-build 5 *columns* 23 #f #f)
  (system-commands 4 desc:system-commands 22 #f #f)
  (desc:system-commands 5 *columns* 21 #f #f)
  (c-libraries 5 desc:c-libraries 20 #f #f)
  (desc:c-libraries 5 *columns* 19 #f #f)
  (platform 4 desc:platform 18 #f #f)
  (desc:platform 5 *columns* 17 #f #f)
  (operating-system 1 desc:operating-system 16 #f #f)
  (desc:operating-system 5 *columns* 15 #f #f)
  (processor-family 2 desc:processor-family 14 #f #f)
  (desc:processor-family 5 *columns* 13 #f #f)
  (*commands* 5 desc:*commands* 12 #f #f)
  (desc:*commands* 5 *columns* 11 #f #f)
  (no-parameter-names 2 desc:no-parameter-names 10 #f #f)
  (desc:no-parameter-names 5 *columns* 9 #f #f)
  (no-parameters 6 *parameter-columns* 8 #f #f)
  (*parameter-columns* 5 *columns* 7 #f #f)
  (parameter-arity 3 desc:parameter-arity 6 #f #f)
  (desc:parameter-arity 5 *columns* 5 #f #f)
  (*columns* 5 *columns* 1 #f #f)
  (*domains-data* 5 *domains-desc* 4 #f #f)
  (*catalog-data* 6 *catalog-desc* 0 #f #f)
  (*domains-desc* 5 *columns* 2 #f #f)
  (*catalog-desc* 5 *columns* 3 #f #f)
 )
 (*base-resources*
  (free-id 31)
 )
)
